diff --git a/src/test/regress/sql/timestamp.sql b/src/test/regress/sql/timestamp.sql
index b22cd48..ad94b23 100644
--- a/src/test/regress/sql/timestamp.sql
+++ b/src/test/regress/sql/timestamp.sql
@@ -225,3 +225,140 @@ SELECT '' AS to_char_11, to_char(d1, 'FMIYYY FMIYY FMIY FMI FMIW FMIDDD FMID')
 
 -- timestamp numeric fields constructor
 SELECT make_timestamp(2014,12,28,6,30,45.887);
+
+-- corner cases
+-- (to prevent raising errors in *_out functions insert values to a table and then select from it)
+SET TIME ZONE 'UTC';
+
+CREATE TABLE test_timestamps(txt TEXT, val timestamp);
+
+-- previously it resulted OK, +inf, -inf, ERROR (in timestamp_out!)
+INSERT INTO test_timestamps SELECT v::text, v::timestamp FROM(VALUES('294277-01-09 04:00:54.775806'))t(v);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, v::timestamp FROM(VALUES('294277-01-09 04:00:54.775807'))t(v);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, v::timestamp FROM(VALUES('294277-01-09 04:00:54.775808'))t(v);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, v::timestamp FROM(VALUES('294277-01-09 04:00:54.775809'))t(v);  -- should fail
+
+-- current corner cases
+INSERT INTO test_timestamps SELECT v::text, v::timestamp FROM(VALUES('4714-11-23 23:59:59.999999 BC'))t(v);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, v::timestamp FROM(VALUES('4714-11-24 00:00:00.000000 BC'))t(v);  -- OK
+INSERT INTO test_timestamps SELECT v::text, v::timestamp FROM(VALUES('4713-01-01 00:00:00.000000 BC'))t(v);  -- OK
+INSERT INTO test_timestamps SELECT v::text, v::timestamp FROM(VALUES('294276-12-31 23:59:59.999999'))t(v);  -- OK
+INSERT INTO test_timestamps SELECT v::text, v::timestamp FROM(VALUES('294276-12-31 24:00:00.000000'))t(v);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, v::timestamp FROM(VALUES('294277-01-01 00:00:00.000000'))t(v);  -- should fail
+
+-- current corner cases with make_timestamp (note: negative years are not allowed)
+INSERT INTO test_timestamps SELECT format('%s-%s-%s %s:%s:%s', y,m,d,h,mm,s), make_timestamp(y,m,d,h,mm,s) FROM(VALUES(294276,12,31, 23,59,59.999999))t(y,m,d,h,mm,s);  -- OK
+INSERT INTO test_timestamps SELECT format('%s-%s-%s %s:%s:%s', y,m,d,h,mm,s), make_timestamp(y,m,d,h,mm,s) FROM(VALUES(294276,12,31, 24,00,00.000000))t(y,m,d,h,mm,s);  -- should fail
+INSERT INTO test_timestamps SELECT format('%s-%s-%s %s:%s:%s', y,m,d,h,mm,s), make_timestamp(y,m,d,h,mm,s) FROM(VALUES(294277,01,01, 00,00,00.000000))t(y,m,d,h,mm,s);  -- should fail
+
+-- conversion from date (has bigger allowed interval)
+INSERT INTO test_timestamps SELECT v::text, v::date::timestamp FROM(VALUES('4714-11-23 BC'))t(v);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, v::date::timestamp FROM(VALUES('4714-11-24 BC'))t(v);  -- OK
+INSERT INTO test_timestamps SELECT v::text, v::date::timestamp FROM(VALUES('294276-12-31'))t(v);  -- OK
+INSERT INTO test_timestamps SELECT v::text, v::date::timestamp FROM(VALUES('294277-01-01'))t(v);  -- should fail
+
+-- conversion from date+time (has bigger allowed interval)
+INSERT INTO test_timestamps SELECT format('%s %s', d::text, t::text), "timestamp"(d::date, t::time) FROM(VALUES('4714-11-23 BC', '23:59:59.999999'))t(d,t);  -- should fail
+INSERT INTO test_timestamps SELECT format('%s %s', d::text, t::text), "timestamp"(d::date, t::time) FROM(VALUES('4714-11-23 BC', '24:00:00.000000'))t(d,t);  -- should fail
+INSERT INTO test_timestamps SELECT format('%s %s', d::text, t::text), "timestamp"(d::date, t::time) FROM(VALUES('4714-11-24 BC', '00:00:00.000000'))t(d,t);  -- OK
+INSERT INTO test_timestamps SELECT format('%s %s', d::text, t::text), "timestamp"(d::date, t::time) FROM(VALUES('294276-12-31',  '23:59:59.999999'))t(d,t);  -- OK
+INSERT INTO test_timestamps SELECT format('%s %s', d::text, t::text), "timestamp"(d::date, t::time) FROM(VALUES('294276-12-31',  '24:00:00.000000'))t(d,t);  -- should fail
+INSERT INTO test_timestamps SELECT format('%s %s', d::text, t::text), "timestamp"(d::date, t::time) FROM(VALUES('294277-01-01',  '00:00:00.000000'))t(d,t);  -- should fail
+
+SELECT txt, val FROM test_timestamps;
+DROP TABLE test_timestamps;
+
+
+-- truncating tests
+CREATE TABLE test_timestamps(txt TEXT, unit text, val timestamp);
+-- truncating minimum allowed value results to even less value (not allowed)
+INSERT INTO test_timestamps SELECT v::text, u, date_trunc(u, v::timestamp) FROM(VALUES('day',   '4714-11-24 00:00:00.000000 BC'))t(u,v);  -- OK
+INSERT INTO test_timestamps SELECT v::text, u, date_trunc(u, v::timestamp) FROM(VALUES('week',  '4714-11-24 00:00:00.000000 BC'))t(u,v);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, u, date_trunc(u, v::timestamp) FROM(VALUES('month', '4714-11-30 23:59:59.999999 BC'))t(u,v);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, u, date_trunc(u, v::timestamp) FROM(VALUES('year',  '4714-12-31 23:59:59.999999 BC'))t(u,v);  -- should fail
+
+SELECT txt, unit, val FROM test_timestamps;
+DROP TABLE test_timestamps;
+
+
+-- time zone conversions tests
+CREATE TABLE test_timestamps(txt TEXT, tz text, val timestamptz);
+INSERT INTO test_timestamps SELECT v::text, tz, v::timestamp AT TIME ZONE tz FROM(VALUES('GMT-1',  '4714-11-24 00:59:59.999999 BC'))t(tz,v);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, tz, v::timestamp AT TIME ZONE tz FROM(VALUES('GMT-1',  '4714-11-24 01:00:00.000000 BC'))t(tz,v);  -- OK
+INSERT INTO test_timestamps SELECT v::text, tz, v::timestamp AT TIME ZONE tz FROM(VALUES('GMT+0',  '4714-11-24 00:59:59.999999 BC'))t(tz,v);  -- OK
+
+INSERT INTO test_timestamps SELECT v::text, tz, v::timestamp AT TIME ZONE tz FROM(VALUES('GMT+0',  '294276-12-31 23:59:59.999999'))t(tz,v);  -- OK
+INSERT INTO test_timestamps SELECT v::text, tz, v::timestamp AT TIME ZONE tz FROM(VALUES('GMT+1',  '294276-12-31 22:59:59.999999'))t(tz,v);  -- OK
+INSERT INTO test_timestamps SELECT v::text, tz, v::timestamp AT TIME ZONE tz FROM(VALUES('GMT+1',  '294276-12-31 23:00:00.000000'))t(tz,v);  -- should fail
+
+SELECT txt, tz, val FROM test_timestamps;
+DROP TABLE test_timestamps;
+
+
+-- arithmetic operations
+CREATE TABLE test_timestamps(txt TEXT, delta INTERVAL, val timestamp);
+
+-- the same as '294277-01-09 04:00:54.77580*'::timestamp (with months)  [should fail]
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294247-01-09', '360 months 04:00:54.775806'))t(v, d);
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294247-01-09', '360 months 04:00:54.775807'))t(v, d);
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294247-01-09', '360 months 04:00:54.775808'))t(v, d);
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294247-01-09', '360 months 04:00:54.775809'))t(v, d);
+
+-- the same as '294277-01-09 04:00:54.77580*'::timestamp (with days)  [should fail]
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294247-01-10', '10957 days 04:00:54.775806'))t(v, d);
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294247-01-10', '10957 days 04:00:54.775807'))t(v, d);
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294247-01-10', '10957 days 04:00:54.775808'))t(v, d);
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294247-01-10', '10957 days 04:00:54.775809'))t(v, d);
+
+-- the same as '294277-01-09 04:00:54.77580*'::timestamp (with hours)  [should fail]
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294247-01-10',        '262972:00:54.775806'))t(v, d);
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294247-01-10',        '262972:00:54.775807'))t(v, d);
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294247-01-10',        '262972:00:54.775808'))t(v, d);
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294247-01-10',        '262972:00:54.775809'))t(v, d);
+
+-- the same as '294277-01-09 04:00:54.77580*'::timestamp (with seconds)  [should fail]
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294247-01-10',           '946699254.775806'))t(v, d);
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294247-01-10',           '946699254.775807'))t(v, d);
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294247-01-10',           '946699254.775808'))t(v, d);
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294247-01-10',           '946699254.775809'))t(v, d);
+
+-- current corner cases
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('4714-11-24 BC', '-1mon'))t(v, d);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('4714-11-24 BC', '-1day'))t(v, d);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('4714-11-24 BC', '-1sec'))t(v, d);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('4714-11-24 BC', '-0.000001sec'))t(v, d);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('4714-11-24 BC', ' 0sec'))t(v, d);  -- OK
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('4714-11-24 BC', '+0.000001sec'))t(v, d);  -- OK
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('4714-11-24 BC', '+1sec'))t(v, d);  -- OK
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('4714-11-24 BC', '+1sec'))t(v, d);  -- OK
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('4714-11-24 BC', '+1day'))t(v, d);  -- OK
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('4714-11-24 BC', '+1mon'))t(v, d);  -- OK
+
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '-1mon'))t(v, d);  -- OK
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '-1day'))t(v, d);  -- OK
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '-1sec'))t(v, d);  -- OK
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '-0.000001sec'))t(v, d);  -- OK
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', ' 0sec'))t(v, d);  -- OK
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '+0.000001sec'))t(v, d);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '+1sec'))t(v, d);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '+1sec'))t(v, d);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '+1day'))t(v, d);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '+1mon'))t(v, d);  -- should fail
+
+-- try to add/substract maximal/minimal intervals (check for unexpected overflow)
+-- years, months
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294276-12-31 23:59:59.999999',  '+2147483647mon'))t(v, d);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294276-12-31 23:59:59.999999',  '-2147483648mon'))t(v, d);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('4714-11-24 01:00:00.000000 BC', '+2147483647mon'))t(v, d);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('4714-11-24 01:00:00.000000 BC', '-2147483648mon'))t(v, d);  -- should fail
+-- days
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294276-12-31 23:59:59.999999',  '+2147483647day'))t(v, d);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('294276-12-31 23:59:59.999999',  '-2147483648day'))t(v, d);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('4714-11-24 01:00:00.000000 BC', '+2147483647day'))t(v, d);  -- should fail
+INSERT INTO test_timestamps SELECT v::text, d::interval, v::timestamp + d::interval FROM(VALUES('4714-11-24 01:00:00.000000 BC', '-2147483648day'))t(v, d);  -- should fail
+
+SELECT txt, delta, val FROM test_timestamps;
+DROP TABLE test_timestamps;
+
+
+RESET TIME ZONE;
